<?php

/**
 * @file
 * Page callbacks for Commerce Z-Payment.
 */

/**
 * Payment result callback.
 */
function commerce_zpayment_result_page_callback() {
  $HTTP = $_POST;
  foreach ($HTTP as $Key=>$Value) { $$Key = $Value; } 
  if (!empty($_POST)) {
    if (isset($_POST['LMI_PREREQUEST']) && $_POST['LMI_PREREQUEST'] == 1) {
      print 'YES';
    } else {
        $order = commerce_order_load($_POST['LMI_PAYMENT_NO']);
        $order_wrapper = entity_metadata_wrapper('commerce_order', $order);
        $payment_method = commerce_payment_method_instance_load($order->data['payment_method']);
        $merch_key = $payment_method['settings']['merchant_key'];
        $err = FALSE;
        if(isset($LMI_SECRET_KEY)) {
            if($LMI_SECRET_KEY!=$merch_key) {
                $err = TRUE;
            }
        } else {
            $CalcHash = md5($LMI_PAYEE_PURSE.$LMI_PAYMENT_AMOUNT.$LMI_PAYMENT_NO.$LMI_MODE.$LMI_SYS_INVS_NO.$LMI_SYS_TRANS_NO.$LMI_SYS_TRANS_DATE.$merch_key.$LMI_PAYER_PURSE.$LMI_PAYER_WM);
            if($LMI_HASH != strtoupper($CalcHash)) {
                $err = TRUE;
            }
        }

        if (!$err) {
            commerce_zpayment_create_transaction($order, $order_wrapper);
         }
         
      }   
  }
}

/**
 * Payment fail callback.
 */
function commerce_zpayment_fail_page_callback() {
  drupal_set_message(t('Payment unsuccessful!'), 'error');

  if (!empty($_POST['LMI_PAYMENT_NO'])) {
    if ($order = commerce_order_load($_POST['LMI_PAYMENT_NO'])) {
      commerce_payment_redirect_pane_previous_page($order);
      drupal_goto(commerce_checkout_order_uri($order));
    }
  }

  drupal_goto('<front>');
}

/**
 * Payment success callback.
 */
function commerce_zpayment_success_page_callback() {
  $keys = array(
    'LMI_PAYMENT_NO',
    'LMI_SYS_INVS_NO',
    'LMI_SYS_TRANS_NO',
    'LMI_SYS_TRANS_DATE',
  );

  $has_error = FALSE;
  foreach ($keys as $key) {
    if (empty($_POST[$key])) {
      $has_error = TRUE;
      break;
    }
  }

  if (!$has_error) {
    if ($order = commerce_order_load($_REQUEST['LMI_PAYMENT_NO'])) {
      drupal_set_message(t('Thank you, payment successful.'));
      commerce_payment_redirect_pane_next_page($order);
      drupal_goto(commerce_checkout_order_uri($order));
    }
  }

  drupal_set_message(t('Unknown error.'));
  drupal_goto('<front>');
}
